Index: trunk/source/processes/hadronic/models/coherent_elastic/src/G4DiffuseElastic.cc
===================================================================
--- trunk/source/processes/hadronic/models/coherent_elastic/src/G4DiffuseElastic.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/coherent_elastic/src/G4DiffuseElastic.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4DiffuseElastic.cc,v 1.20 2008/01/14 10:39:13 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4DiffuseElastic.cc,v 1.23 2009/03/02 09:17:43 grichine Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
@@ -67,5 +67,5 @@
 {
   SetMinEnergy( 0.01*GeV );
-  SetMaxEnergy( 100.*TeV );
+  SetMaxEnergy( 1.*TeV );
   verboseLevel = 0;
   lowEnergyRecoilLimit = 100.*keV;  
@@ -83,7 +83,7 @@
 
   fEnergyBin = 200;
-  fAngleBin = 100;
-
-  fEnergyVector = 0;
+  fAngleBin  = 200;
+
+  fEnergyVector =  new G4PhysicsLogVector( theMinEnergy, theMaxEnergy, fEnergyBin );
   fAngleTable = 0;
 
@@ -107,5 +107,5 @@
 {
   SetMinEnergy( 0.01*GeV );
-  SetMaxEnergy( 100.*TeV );
+  SetMaxEnergy( 1.*TeV );
   verboseLevel = 0;
   lowEnergyRecoilLimit = 100.*keV;  
@@ -122,6 +122,6 @@
   thePionMinus= G4PionMinus::PionMinus();
 
-  fEnergyBin = 200;
-  fAngleBin = 100;
+  fEnergyBin = 200; // 200; // 100;
+  fAngleBin  = 400; // 200; // 100;
 
   // fEnergyVector = 0;
@@ -174,7 +174,10 @@
     fAtomicWeight = (*theElementTable)[jEl]->GetN();     // number of nucleons
     fNuclearRadius = CalculateNuclearRad(fAtomicWeight);
-    if(verboseLevel > 0)    
+
+    if(verboseLevel > 0) 
+    {   
       G4cout<<"G4DiffuseElastic::Initialise() the element: "
 	    <<(*theElementTable)[jEl]->GetName()<<G4endl;
+    }
     fElementNumberVector.push_back(fAtomicNumber);
     fElementNameVector.push_back((*theElementTable)[jEl]->GetName());
@@ -183,83 +186,4 @@
     fAngleBank.push_back(fAngleTable);
   }  
-  return;
-}
-
-//////////////////////////////////////////////////////////////////////////////
-//
-// Initialisation for given particle on fly using new element number
-
-void G4DiffuseElastic::InitialiseOnFly(G4double Z, G4double A) 
-{
-  fAtomicNumber = Z;     // atomic number
-  fAtomicWeight = A;     // number of nucleons
-  fNuclearRadius = CalculateNuclearRad(fAtomicWeight);
-  if(verboseLevel > 0)    
-    G4cout<<"G4DiffuseElastic::Initialise() the element with Z = "
-	  <<Z<<"; and A = "<<A<<G4endl;
-  fElementNumberVector.push_back(fAtomicNumber);
-
-  BuildAngleTable();
-  fAngleBank.push_back(fAngleTable);
-  return;
-}
-
-///////////////////////////////////////////////////////////////////////////////
-//
-// Build for given particle and element table of momentum, angle probability.
-// For the moment in lab system. 
-
-void G4DiffuseElastic::BuildAngleTable() 
-{
-  G4int i, j;
-  G4double partMom, kinE, a=0., z = fParticle->GetPDGCharge(), m1 = fParticle->GetPDGMass();
-  G4double theta1, theta2, thetaMax, thetaCoulomb, sum = 0.;
-
-  G4Integrator<G4DiffuseElastic,G4double(G4DiffuseElastic::*)(G4double)> integral;
-  
-  fAngleTable = new G4PhysicsTable(fEnergyBin);
-
-  for(i = 0; i < fEnergyBin; i++)
-  {
-    kinE        = fEnergyVector->GetLowEdgeEnergy(i);
-    partMom     = std::sqrt( kinE*(kinE + 2*m1) );
-    fWaveVector = partMom/hbarc;
-
-    thetaMax    = 10.174/fWaveVector/fNuclearRadius;
-
-    if (thetaMax > pi) thetaMax = pi;
-
-    thetaCoulomb = 0.2*thetaMax;
-
-    if(z)
-    {
-      a = partMom/m1;
-      fBeta          = a/std::sqrt(1+a*a);
-      fZommerfeld    = CalculateZommerfeld( fBeta, z, fAtomicNumber);
-      fAm            = CalculateAm( partMom, fZommerfeld, fAtomicNumber);
-    }
-    G4PhysicsFreeVector* angleVector = new G4PhysicsFreeVector(fAngleBin);
-
-    G4PhysicsLogVector*  angleBins = new G4PhysicsLogVector( 0.01*thetaMax, thetaMax, fAngleBin );
-
-    for(j = 1; j < fAngleBin; j++)
-    {
-      theta1 = angleBins->GetLowEdgeEnergy(j-1);
-      theta2 = angleBins->GetLowEdgeEnergy(j);
-
-      if(theta2 > thetaCoulomb && z) fAddCoulomb = true;
-
-      sum   += integral.Legendre10(this,&G4DiffuseElastic::GetIntegrandFunction, theta1,theta2);
-      
-      angleVector->PutValue( j-1 , theta2, sum );
-      // G4cout<<"j-1 = "<<j-1<<"; theta2 = "<<theta2<<"; sum = "<<sum<<G4endl;
-    }
-    fAddCoulomb = false;
-
-    fAngleTable->insertAt(i,angleVector);
-
-    // delete[] angleVector; 
-    // delete[] angleBins; 
-  }
   return;
 }
@@ -525,14 +449,19 @@
   fAtomicWeight  = A;
   fAtomicNumber  = Z;
-  G4double z             = particle->GetPDGCharge();
-  if(z)
+  fNuclearRadius = CalculateNuclearRad(A);
+  fAddCoulomb    = false;
+
+  G4double z     = particle->GetPDGCharge();
+
+  G4double kRt   = fWaveVector*fNuclearRadius*theta;
+  G4double kRtC  = 1.9;
+
+  if( z && (kRt > kRtC) )
   {
     fAddCoulomb = true;
-    fBeta          = CalculateParticleBeta( particle, momentum);
-    fZommerfeld    = CalculateZommerfeld( fBeta, z, fAtomicNumber);
-    fAm            = CalculateAm( momentum, fZommerfeld, fAtomicNumber);
-  }
-  fNuclearRadius = CalculateNuclearRad(A);
-
+    fBeta       = CalculateParticleBeta( particle, momentum);
+    fZommerfeld = CalculateZommerfeld( fBeta, z, fAtomicNumber);
+    fAm         = CalculateAm( momentum, fZommerfeld, fAtomicNumber);
+  }
   G4double sigma = fNuclearRadius*fNuclearRadius*GetDiffElasticSumProb(theta);
 
@@ -552,9 +481,11 @@
 {
   G4double m1 = particle->GetPDGMass();
+
   G4LorentzVector lv1(0.,0.,plab,std::sqrt(plab*plab+m1*m1));
 
   G4int iZ = static_cast<G4int>(Z+0.5);
   G4int iA = static_cast<G4int>(A+0.5);
-  G4ParticleDefinition * theDef = 0;
+
+  G4ParticleDefinition* theDef = 0;
 
   if      (iZ == 1 && iA == 1) theDef = theProton;
@@ -575,6 +506,6 @@
   G4ThreeVector p1 = lv1.vect();
   G4double ptot    = p1.mag();
-  G4double ptot2 = ptot*ptot;
-  G4double cost = 1 - 0.5*std::fabs(tMand)/ptot2;
+  G4double ptot2   = ptot*ptot;
+  G4double cost    = 1 - 0.5*std::fabs(tMand)/ptot2;
 
   if( cost >= 1.0 )      cost = 1.0;  
@@ -658,4 +589,5 @@
   // G4double r0    = 1.08*fermi;
   // G4double rad   = r0*std::pow(A, 1./3.);
+
   G4double kr    = fWaveVector*fNuclearRadius; // wavek*rad;
   G4double kr2   = kr*kr;
@@ -686,10 +618,14 @@
   }
   G4double lambda = 15.; // 15 ok
+
   //  G4double kg    = fWaveVector*gamma;   // wavek*delta;
+
   G4double kg    = lambda*(1.-std::exp(-fWaveVector*gamma/lambda));   // wavek*delta;
   G4double kg2   = kg*kg;
+
   // G4double dk2t  = delta*fWaveVector*fWaveVector*theta; // delta*wavek*wavek*theta;
   // G4double dk2t2 = dk2t*dk2t;
   // G4double pikdt = pi*fWaveVector*diffuse*theta;// pi*wavek*diffuse*theta;
+
   G4double pikdt    = lambda*(1.-std::exp(-pi*fWaveVector*diffuse*theta/lambda));   // wavek*delta;
 
@@ -730,4 +666,5 @@
   // G4double r0    = 1.08*fermi;
   // G4double rad   = r0*std::pow(A, 1./3.);
+
   G4double kr    = fWaveVector*fNuclearRadius; // wavek*rad;
   G4double kr2   = kr*kr;
@@ -774,11 +711,10 @@
 
   G4double kg2   = kg*kg;
+
   // G4double dk2t  = delta*fWaveVector*fWaveVector*theta; // delta*wavek*wavek*theta;
-
   //   G4cout<<"dk2t = "<<dk2t<<G4endl;
-
   // G4double dk2t2 = dk2t*dk2t;
-
   // G4double pikdt = pi*fWaveVector*diffuse*theta;// pi*wavek*diffuse*theta;
+
   G4double pikdt    = lambda*(1.-std::exp(-pi*fWaveVector*diffuse*theta/lambda));   // wavek*delta;
 
@@ -808,13 +744,112 @@
 ////////////////////////////////////////////////////////////////////////////
 //
+// return differential elastic probability d(probability)/d(t) with 
+// Coulomb correction
+
+G4double 
+G4DiffuseElastic::GetDiffElasticSumProbA( G4double alpha )
+{
+  G4double theta; 
+
+  theta = std::sqrt(alpha);
+
+  // theta = std::acos( 1 - alpha/2. );
+
+  G4double sigma, bzero, bzero2, bonebyarg, bonebyarg2, damp, damp2;
+  G4double delta, diffuse, gamma;
+  G4double e1, e2, bone, bone2;
+
+  // G4double wavek = momentum/hbarc;  // wave vector
+  // G4double r0    = 1.08*fermi;
+  // G4double rad   = r0*std::pow(A, 1./3.);
+
+  G4double kr    = fWaveVector*fNuclearRadius; // wavek*rad;
+  G4double kr2   = kr*kr;
+  G4double krt   = kr*theta;
+
+  bzero      = BesselJzero(krt);
+  bzero2     = bzero*bzero;    
+  bone       = BesselJone(krt);
+  bone2      = bone*bone;
+  bonebyarg  = BesselOneByArg(krt);
+  bonebyarg2 = bonebyarg*bonebyarg;  
+
+  if (fParticle == theProton)
+  {
+    diffuse = 0.63*fermi;
+    // diffuse = 0.6*fermi;
+    gamma   = 0.3*fermi;
+    delta   = 0.1*fermi*fermi;
+    e1      = 0.3*fermi;
+    e2      = 0.35*fermi;
+  }
+  else // as proton, if were not defined 
+  {
+    diffuse = 0.63*fermi;
+    gamma   = 0.3*fermi;
+    delta   = 0.1*fermi*fermi;
+    e1      = 0.3*fermi;
+    e2      = 0.35*fermi;
+  }
+  G4double lambda = 15.; // 15 ok
+  // G4double kg    = fWaveVector*gamma;   // wavek*delta;
+  G4double kg    = lambda*(1.-std::exp(-fWaveVector*gamma/lambda));   // wavek*delta;
+
+  // G4cout<<"kg = "<<kg<<G4endl;
+
+  if(fAddCoulomb)  // add Coulomb correction
+  {
+    G4double sinHalfTheta  = theta*0.5; // std::sin(0.5*theta);
+    G4double sinHalfTheta2 = sinHalfTheta*sinHalfTheta;
+
+    kg += 0.5*fZommerfeld/kr/(sinHalfTheta2+fAm); // correction at J0()
+  // kg += 0.65*fZommerfeld/kr/(sinHalfTheta2+fAm); // correction at J0()
+  }
+
+  G4double kg2   = kg*kg;
+
+  // G4double dk2t  = delta*fWaveVector*fWaveVector*theta; // delta*wavek*wavek*theta;
+  //   G4cout<<"dk2t = "<<dk2t<<G4endl;
+  // G4double dk2t2 = dk2t*dk2t;
+  // G4double pikdt = pi*fWaveVector*diffuse*theta;// pi*wavek*diffuse*theta;
+
+  G4double pikdt    = lambda*(1.-std::exp(-pi*fWaveVector*diffuse*theta/lambda));   // wavek*delta;
+
+  // G4cout<<"pikdt = "<<pikdt<<G4endl;
+
+  damp           = DampFactor(pikdt);
+  damp2          = damp*damp;
+
+  G4double mode2k2 = (e1*e1+e2*e2)*fWaveVector*fWaveVector;  
+  G4double e2dk3t  = -2.*e2*delta*fWaveVector*fWaveVector*fWaveVector*theta;
+
+  sigma  = kg2;
+  // sigma += dk2t2;
+  sigma *= bzero2;
+  sigma += mode2k2*bone2; 
+  sigma += e2dk3t*bzero*bone;
+
+  // sigma += kr2*(1 + 8.*fZommerfeld*fZommerfeld/kr2)*bonebyarg2;  // correction at J1()/()
+  sigma += kr2*bonebyarg2;  // correction at J1()/()
+
+  sigma *= damp2;          // *rad*rad;
+
+  return sigma;
+}
+
+
+////////////////////////////////////////////////////////////////////////////
+//
 // return differential elastic probability 2*pi*sin(theta)*d(probability)/d(omega) 
 
 G4double 
-G4DiffuseElastic::GetIntegrandFunction( G4double theta )
+G4DiffuseElastic::GetIntegrandFunction( G4double alpha )
 {
   G4double result;
 
-  result  = 2*pi*std::sin(theta);
-  result *= GetDiffElasticSumProb(theta);
+  result  = GetDiffElasticSumProbA(alpha);
+
+  // result *= 2*pi*std::sin(theta);
+
   return result;
 }
@@ -859,16 +894,4 @@
 ////////////////////////////////////////////////////////////////////////////
 //
-// Return inv momentum transfer -t > 0 from initialisation table
-
-G4double G4DiffuseElastic::SampleTableT( const G4ParticleDefinition* aParticle, G4double p, 
-                                               G4double Z, G4double A)
-{
-  G4double theta = SampleTableThetaCMS( aParticle,  p, Z, A); // sample theta in cms
-  G4double t     = 2*p*p*( 1 - std::cos(theta) ); // -t !!!
-  return t;
-}
-
-////////////////////////////////////////////////////////////////////////////
-//
 // Return scattering angle sampled in cms
 
@@ -922,7 +945,22 @@
 }
 
-////////////////////////////////////////////////////////////////////////////
-//
-// Return scattering angle sampled in cms according to precalculated table.
+/////////////////////////////////////////////////////////////////////////////
+/////////////////////  Table preparation and reading ////////////////////////
+////////////////////////////////////////////////////////////////////////////
+//
+// Return inv momentum transfer -t > 0 from initialisation table
+
+G4double G4DiffuseElastic::SampleTableT( const G4ParticleDefinition* aParticle, G4double p, 
+                                               G4double Z, G4double A)
+{
+  G4double alpha = SampleTableThetaCMS( aParticle,  p, Z, A); // sample theta2 in cms
+  // G4double t     = 2*p*p*( 1 - std::cos(std::sqrt(alpha)) );             // -t !!!
+  G4double t     = p*p*alpha;             // -t !!!
+  return t;
+}
+
+////////////////////////////////////////////////////////////////////////////
+//
+// Return scattering angle2 sampled in cms according to precalculated table.
 
 
@@ -942,5 +980,6 @@
   if ( iElement == fElementNumberVector.size() ) 
   {
-    InitialiseOnFly(Z,A);
+    InitialiseOnFly(Z,A); // table preparation, if needed
+
     // iElement--;
 
@@ -955,58 +994,73 @@
   G4double kinE = std::sqrt(momentum*momentum + m1*m1) - m1;
 
-  for(iMomentum = 0; iMomentum < fEnergyBin; iMomentum++)
+  for( iMomentum = 0; iMomentum < fEnergyBin; iMomentum++)
   {
     if( kinE < fEnergyVector->GetLowEdgeEnergy(iMomentum) ) break;
   }
-  if ( iMomentum == fEnergyBin ) iMomentum--;   // kinE is more then theMaxEnergy
+  if ( iMomentum >= fEnergyBin ) iMomentum = fEnergyBin-1;   // kinE is more then theMaxEnergy
   if ( iMomentum < 0 )           iMomentum = 0; // against negative index, kinE < theMinEnergy
+
   // G4cout<<"iMomentum = "<<iMomentum<<G4endl;
 
-  if (iMomentum == fEnergyBin -1 || iMomentum == 0 ) // the table edges
+  if (iMomentum == fEnergyBin -1 || iMomentum == 0 )   // the table edges
   {
     position = (*(*fAngleTable)(iMomentum))(fAngleBin-2)*G4UniformRand();
+
     // G4cout<<"position = "<<position<<G4endl;
 
-    for(iAngle = 0; iAngle < fAngleBin; iAngle++)
+    for(iAngle = 0; iAngle < fAngleBin-1; iAngle++)
     {
       if( position < (*(*fAngleTable)(iMomentum))(iAngle) ) break;
     }
-    if (iAngle == fAngleBin) iAngle--;
+    if (iAngle >= fAngleBin-1) iAngle = fAngleBin-2;
+
     // G4cout<<"iAngle = "<<iAngle<<G4endl;
 
     randAngle = GetScatteringAngle(iMomentum, iAngle, position);
+
     // G4cout<<"randAngle = "<<randAngle<<G4endl;
   }
-  else
-  {
-    position = (*(*fAngleTable)(iMomentum))(fAngleBin-2)*G4UniformRand();
+  else  // kinE inside between energy table edges
+  {
+    // position = (*(*fAngleTable)(iMomentum))(fAngleBin-2)*G4UniformRand();
+    position = (*(*fAngleTable)(iMomentum))(0)*G4UniformRand();
+
     // G4cout<<"position = "<<position<<G4endl;
 
-    for(iAngle = 0; iAngle < fAngleBin; iAngle++)
+    for(iAngle = 0; iAngle < fAngleBin-1; iAngle++)
     {
-      if( position < (*(*fAngleTable)(iMomentum))(iAngle) ) break;
+      // if( position < (*(*fAngleTable)(iMomentum))(iAngle) ) break;
+      if( position > (*(*fAngleTable)(iMomentum))(iAngle) ) break;
     }
-    if (iAngle == fAngleBin) iAngle--;
+    if (iAngle >= fAngleBin-1) iAngle = fAngleBin-2;
+
     // G4cout<<"iAngle = "<<iAngle<<G4endl;
 
     theta2  = GetScatteringAngle(iMomentum, iAngle, position);
+
     // G4cout<<"theta2 = "<<theta2<<G4endl;
     E2 = fEnergyVector->GetLowEdgeEnergy(iMomentum);
+
     // G4cout<<"E2 = "<<E2<<G4endl;
-
+    
     iMomentum--;
-
-    position = (*(*fAngleTable)(iMomentum))(fAngleBin-2)*G4UniformRand();
+    
+    // position = (*(*fAngleTable)(iMomentum))(fAngleBin-2)*G4UniformRand();
+
     // G4cout<<"position = "<<position<<G4endl;
 
-    for(iAngle = 0; iAngle < fAngleBin; iAngle++)
+    for(iAngle = 0; iAngle < fAngleBin-1; iAngle++)
     {
-      if( position < (*(*fAngleTable)(iMomentum))(iAngle) ) break;
+      // if( position < (*(*fAngleTable)(iMomentum))(iAngle) ) break;
+      if( position > (*(*fAngleTable)(iMomentum))(iAngle) ) break;
     }
-    if (iAngle == fAngleBin) iAngle--;
-
+    if (iAngle >= fAngleBin-1) iAngle = fAngleBin-2;
+    
     theta1  = GetScatteringAngle(iMomentum, iAngle, position);
+
     // G4cout<<"theta1 = "<<theta1<<G4endl;
+
     E1 = fEnergyVector->GetLowEdgeEnergy(iMomentum);
+
     // G4cout<<"E1 = "<<E1<<G4endl;
 
@@ -1016,9 +1070,124 @@
 
     randAngle = W1*theta1 + W2*theta2;
+    
+    // randAngle = theta2;
     // G4cout<<"randAngle = "<<randAngle<<G4endl;
   }
+  // G4double angle = randAngle;
+  // if (randAngle > 0.) randAngle /= 2*pi*std::sin(angle);
+
   return randAngle;
 }
 
+//////////////////////////////////////////////////////////////////////////////
+//
+// Initialisation for given particle on fly using new element number
+
+void G4DiffuseElastic::InitialiseOnFly(G4double Z, G4double A) 
+{
+  fAtomicNumber  = Z;     // atomic number
+  fAtomicWeight  = A;     // number of nucleons
+
+  fNuclearRadius = CalculateNuclearRad(fAtomicWeight);
+  
+  if( verboseLevel > 0 )    
+  {
+    G4cout<<"G4DiffuseElastic::Initialise() the element with Z = "
+	  <<Z<<"; and A = "<<A<<G4endl;
+  }
+  fElementNumberVector.push_back(fAtomicNumber);
+
+  BuildAngleTable();
+
+  fAngleBank.push_back(fAngleTable);
+
+  return;
+}
+
+///////////////////////////////////////////////////////////////////////////////
+//
+// Build for given particle and element table of momentum, angle probability.
+// For the moment in lab system. 
+
+void G4DiffuseElastic::BuildAngleTable() 
+{
+  G4int i, j;
+  G4double partMom, kinE, a = 0., z = fParticle->GetPDGCharge(), m1 = fParticle->GetPDGMass();
+  G4double alpha1, alpha2, alphaMax, alphaCoulomb, delta = 0., sum = 0.;
+
+  G4Integrator<G4DiffuseElastic,G4double(G4DiffuseElastic::*)(G4double)> integral;
+  
+  fAngleTable = new G4PhysicsTable(fEnergyBin);
+
+  for( i = 0; i < fEnergyBin; i++)
+  {
+    kinE        = fEnergyVector->GetLowEdgeEnergy(i);
+    partMom     = std::sqrt( kinE*(kinE + 2*m1) );
+
+    fWaveVector = partMom/hbarc;
+
+    G4double kR     = fWaveVector*fNuclearRadius;
+    G4double kR2    = kR*kR;
+    G4double kRmax  = 18.6; // 10.6; 10.6, 18, 10.174; ~ 3 maxima of J1 or 15., 25.
+    G4double kRcoul = 1.9; // 1.2; 1.4, 2.5; // on the first slope of J1
+    // G4double kRlim  = 1.2;
+    // G4double kRlim2 = kRlim*kRlim/kR2;
+
+    alphaMax = kRmax*kRmax/kR2;
+
+    if (alphaMax > 4.) alphaMax = 4.;  // vmg05-02-09: was pi2 
+
+    alphaCoulomb = kRcoul*kRcoul/kR2;
+
+    if( z )
+    {
+      a           = partMom/m1;         // beta*gamma for m1
+      fBeta       = a/std::sqrt(1+a*a);
+      fZommerfeld = CalculateZommerfeld( fBeta, z, fAtomicNumber);
+      fAm         = CalculateAm( partMom, fZommerfeld, fAtomicNumber);
+    }
+    G4PhysicsFreeVector* angleVector = new G4PhysicsFreeVector(fAngleBin-1);
+
+    // G4PhysicsLogVector*  angleBins = new G4PhysicsLogVector( 0.001*alphaMax, alphaMax, fAngleBin );
+
+    G4double delth = alphaMax/fAngleBin;
+        
+    sum = 0.;
+
+    // fAddCoulomb = false;
+    fAddCoulomb = true;
+
+    // for(j = 1; j < fAngleBin; j++)
+    for(j = fAngleBin-1; j >= 1; j--)
+    {
+      // alpha1 = angleBins->GetLowEdgeEnergy(j-1);
+      // alpha2 = angleBins->GetLowEdgeEnergy(j);
+
+      // alpha1 = alphaMax*(j-1)/fAngleBin;
+      // alpha2 = alphaMax*( j )/fAngleBin;
+
+      alpha1 = delth*(j-1);
+      // if(alpha1 < kRlim2) alpha1 = kRlim2;
+      alpha2 = alpha1 + delth;
+
+      // if( ( alpha2 > alphaCoulomb ) && z ) fAddCoulomb = true;
+      if( ( alpha1 < alphaCoulomb ) && z ) fAddCoulomb = false;
+
+      delta = integral.Legendre10(this, &G4DiffuseElastic::GetIntegrandFunction, alpha1, alpha2);
+      // delta = integral.Legendre96(this, &G4DiffuseElastic::GetIntegrandFunction, alpha1, alpha2);
+
+      sum += delta;
+      
+      angleVector->PutValue( j-1 , alpha1, sum ); // alpha2
+      // G4cout<<"j-1 = "<<j-1<<"; alpha2 = "<<alpha2<<"; sum = "<<sum<<G4endl;
+    }
+    fAngleTable->insertAt(i,angleVector);
+
+    // delete[] angleVector; 
+    // delete[] angleBins; 
+  }
+  return;
+}
+
 /////////////////////////////////////////////////////////////////////////////////
 //
@@ -1026,5 +1195,5 @@
 
 G4double 
-G4DiffuseElastic:: GetScatteringAngle(G4int iMomentum, G4int iAngle, G4double position)
+G4DiffuseElastic:: GetScatteringAngle( G4int iMomentum, G4int iAngle, G4double position )
 {
  G4double x1, x2, y1, y2, randAngle;
@@ -1033,4 +1202,5 @@
   {
     randAngle = (*fAngleTable)(iMomentum)->GetLowEdgeEnergy(iAngle);
+    // iAngle++;
   }
   else
@@ -1046,11 +1216,11 @@
     x2 = (*fAngleTable)(iMomentum)->GetLowEdgeEnergy(iAngle);
 
-    if ( x1 == x2 )    randAngle = x2;
+    if ( x1 == x2 )   randAngle = x2;
     else
     {
-      if ( y1 == y2  ) randAngle = x1 + (x2 - x1)*G4UniformRand();
+      if ( y1 == y2 ) randAngle = x1 + ( x2 - x1 )*G4UniformRand();
       else
       {
-        randAngle = x1 + (position - y1)*(x2 - x1)/(y2 - y1);
+        randAngle = x1 + ( position - y1 )*( x2 - x1 )/( y2 - y1 );
       }
     }
@@ -1270,4 +1440,108 @@
 }
 
+///////////////////////////////////////////////////////////////////////////////
+//
+// Test for given particle and element table of momentum, angle probability.
+// For the moment in lab system. 
+
+void G4DiffuseElastic::TestAngleTable(const G4ParticleDefinition* theParticle, G4double partMom,
+                                            G4double Z, G4double A) 
+{
+  fAtomicNumber  = Z;     // atomic number
+  fAtomicWeight  = A;     // number of nucleons
+  fNuclearRadius = CalculateNuclearRad(fAtomicWeight);
+  
+     
+  
+  G4cout<<"G4DiffuseElastic::TestAngleTable() init the element with Z = "
+	  <<Z<<"; and A = "<<A<<G4endl;
+ 
+  fElementNumberVector.push_back(fAtomicNumber);
+
+ 
+
+
+  G4int i=0, j;
+  G4double a = 0., z = theParticle->GetPDGCharge(),  m1 = fParticle->GetPDGMass();
+  G4double alpha1=0., alpha2=0., alphaMax=0., alphaCoulomb=0.;
+  G4double deltaL10 = 0., deltaL96 = 0., deltaAG = 0.;
+  G4double sumL10 = 0.,sumL96 = 0.,sumAG = 0.;
+  G4double epsilon = 0.001;
+
+  G4Integrator<G4DiffuseElastic,G4double(G4DiffuseElastic::*)(G4double)> integral;
+  
+  fAngleTable = new G4PhysicsTable(fEnergyBin);
+
+  fWaveVector = partMom/hbarc;
+
+  G4double kR     = fWaveVector*fNuclearRadius;
+  G4double kR2    = kR*kR;
+  G4double kRmax  = 10.6; // 10.6, 18, 10.174; ~ 3 maxima of J1 or 15., 25.
+  G4double kRcoul = 1.2; // 1.4, 2.5; // on the first slope of J1
+
+  alphaMax = kRmax*kRmax/kR2;
+
+  if (alphaMax > 4.) alphaMax = 4.;  // vmg05-02-09: was pi2 
+
+  alphaCoulomb = kRcoul*kRcoul/kR2;
+
+  if( z )
+  {
+      a           = partMom/m1; // beta*gamma for m1
+      fBeta       = a/std::sqrt(1+a*a);
+      fZommerfeld = CalculateZommerfeld( fBeta, z, fAtomicNumber);
+      fAm         = CalculateAm( partMom, fZommerfeld, fAtomicNumber);
+  }
+  G4PhysicsFreeVector* angleVector = new G4PhysicsFreeVector(fAngleBin-1);
+
+  // G4PhysicsLogVector*  angleBins = new G4PhysicsLogVector( 0.001*alphaMax, alphaMax, fAngleBin );
+    
+  
+  fAddCoulomb = false;
+
+  for(j = 1; j < fAngleBin; j++)
+  {
+      // alpha1 = angleBins->GetLowEdgeEnergy(j-1);
+      // alpha2 = angleBins->GetLowEdgeEnergy(j);
+
+    alpha1 = alphaMax*(j-1)/fAngleBin;
+    alpha2 = alphaMax*( j )/fAngleBin;
+
+    if( ( alpha2 > alphaCoulomb ) && z ) fAddCoulomb = true;
+
+    deltaL10 = integral.Legendre10(this, &G4DiffuseElastic::GetIntegrandFunction, alpha1, alpha2);
+    deltaL96 = integral.Legendre96(this, &G4DiffuseElastic::GetIntegrandFunction, alpha1, alpha2);
+    deltaAG  = integral.AdaptiveGauss(this, &G4DiffuseElastic::GetIntegrandFunction, 
+                                       alpha1, alpha2,epsilon);
+
+      // G4cout<<alpha1<<"\t"<<std::sqrt(alpha1)/degree<<"\t"
+      //     <<deltaL10<<"\t"<<deltaL96<<"\t"<<deltaAG<<G4endl;
+
+    sumL10 += deltaL10;
+    sumL96 += deltaL96;
+    sumAG  += deltaAG;
+
+    G4cout<<alpha1<<"\t"<<std::sqrt(alpha1)/degree<<"\t"
+            <<sumL10<<"\t"<<sumL96<<"\t"<<sumAG<<G4endl;
+      
+    angleVector->PutValue( j-1 , alpha1, sumL10 ); // alpha2
+  }
+  fAngleTable->insertAt(i,angleVector);
+  fAngleBank.push_back(fAngleTable);
+
+  /*
+  // Integral over all angle range - Bad accuracy !!!
+
+  sumL10 = integral.Legendre10(this, &G4DiffuseElastic::GetIntegrandFunction, 0., alpha2);
+  sumL96 = integral.Legendre96(this, &G4DiffuseElastic::GetIntegrandFunction, 0., alpha2);
+  sumAG  = integral.AdaptiveGauss(this, &G4DiffuseElastic::GetIntegrandFunction, 
+                                       0., alpha2,epsilon);
+  G4cout<<G4endl;
+  G4cout<<alpha2<<"\t"<<std::sqrt(alpha2)/degree<<"\t"
+            <<sumL10<<"\t"<<sumL96<<"\t"<<sumAG<<G4endl;
+  */
+  return;
+}
+
 //
 //
Index: trunk/source/processes/hadronic/models/de_excitation/History
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/History	(revision 1007)
+++ trunk/source/processes/hadronic/models/de_excitation/History	(revision 1055)
@@ -14,4 +14,59 @@
      * Please list in reverse chronological order (last date on top)
      ---------------------------------------------------------------
+
+13 March 2009 Vladimir Ivanchenko (hadr-deex-V09-02-09)
+---------------------------------------------------------
+- G4CompetitiveFission - fixed 4-momentum balance by using direct Lorentz 
+                         computations (JMQ);
+                       - use G4 units (VI).
+
+12 March 2009 Alexander Howard (hadr-deex-V09-02-08)
+----------------------------------------------------
+- Added Tatsumi's fixes ( G4GEMProbability.cc and G4GEMChannel.cc ) to GEM 
+  on top of patch9-02 ("hadr-deex-V09-02-07" and "hadr-deex-util-V09-02-00")
+
+04 March 2009 Gabriele Cosmo
+----------------------------
+- Fixed leaks in singleton classes in the 'util' module. Corrected wherever
+  needed inlining of constructors/destructors for base classes and usage of
+  virtual specification. Corresponds to tag "hadr-deex-util-V09-02-00".
+
+15 February 2009 Vladimir Ivanchenko (hadr-deex-V09-02-07)
+---------------------------------------------------------
+- G4EvaporationProbability - hbar_Plank substituted by hbarc (JMQ fix)
+- G4FissionProbability - fixed forgotten parenthesis (JMQ fix) 
+
+13 February 2009 Vladimir Ivanchenko (hadr-deex-V09-02-06)
+---------------------------------------------------------
+- Jose Manuel Quesada change the shape of probabilities (back to 9.2)
+  for d, t, He3, alpha near the Coulomb barrier
+
+12 February 2009 Vladimir Ivanchenko (hadr-deex-V09-02-05)
+---------------------------------------------------------
+- Jose Manuel Quesada change the shape of probabilities 
+  for d, t, He3, alpha near the Coulomb barrier
+
+11 February 2009 Vladimir Ivanchenko (hadr-deex-V09-02-04)
+---------------------------------------------------------
+- Jose Manuel Quesada set default OPT=3 back for all particles
+  and add smearing of Coloumb barriers of d, t, he3, alpha 
+
+10 February 2009 Vladimir Ivanchenko (hadr-deex-V09-02-03)
+---------------------------------------------------------
+- Exclude updated G4VGammaDeexcitation
+
+10 February 2009 Vladimir Ivanchenko (hadr-deex-V09-02-02)
+---------------------------------------------------------
+- Jose Manuel Quesada set default OPT=3 for evaporation of protons 
+  and neutrons and OPT=1 for deuterons, tritons, alpha and He3
+
+10 February 2009 Vladimir Ivanchenko (hadr-deex-V09-02-01)
+---------------------------------------------------------
+- Miguel Cortes added extra protection to G4VGammaDeexcitation
+
+27 January 2009 Vladimir Ivanchenko (hadr-deex-V09-02-00)
+--------------------------------------------------------
+- Miguel Cortes fix of Lorentz transformation in G4VGammaDeexcitation,
+  which provides Doppler broading of gamma lines
 
 09 December 2008 Alexander Howard (hadr-deex-V09-01-25)
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4AlphaEvaporationProbability.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4AlphaEvaporationProbability.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4AlphaEvaporationProbability.cc	(revision 1055)
@@ -104,5 +104,6 @@
 //OPT=3,4 Kalbach's parameterization 
 // 
- G4double G4AlphaEvaporationProbability::CrossSection(const  G4Fragment & fragment, const  G4double K)
+G4double G4AlphaEvaporationProbability::CrossSection(const  G4Fragment & fragment, 
+						     const  G4double K)
 {
   theA=GetA();
@@ -117,5 +118,6 @@
   
   if (OPTxs==0) {std::ostringstream errOs;
-    errOs << "We should'n be here (OPT =0) at evaporation cross section calculation (Alpha's)!!"  <<G4endl;
+    errOs << "We should'n be here (OPT =0) at evaporation cross section calculation (Alpha's)!!"  
+	  <<G4endl;
     throw G4HadronicException(__FILE__, __LINE__, errOs.str());
     return 0.;}
@@ -203,5 +205,7 @@
   G4double      ra=1.20;
   
-  ec = 1.44 * theZ * ResidualZ / (1.5*ResidualAthrd+ra);
+  //JMQ 13/02/09 increase of reduced radius to lower the barrier
+  // ec = 1.44 * theZ * ResidualZ / (1.5*ResidualAthrd+ra);
+  ec = 1.44 * theZ * ResidualZ / (1.7*ResidualAthrd+ra);
   ecsq = ec * ec;
   p = p0 + p1/ec + p2/ecsq;
@@ -226,5 +230,5 @@
   
   if (elab <= ec) { //start for E<Ec
-    if (elab > ecut2)  sig = (p*elab*elab+a*elab+b) * signor;    
+    if (elab > ecut2)  sig = (p*elab*elab+a*elab+b) * signor;
   }           //end for E<Ec
   else {           //start for E>Ec
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4DeuteronEvaporationProbability.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4DeuteronEvaporationProbability.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4DeuteronEvaporationProbability.cc	(revision 1055)
@@ -106,5 +106,5 @@
 //OPT=3,4 Kalbach's parameterization 
 // 
- G4double G4DeuteronEvaporationProbability::CrossSection(const  G4Fragment & fragment, const  G4double K)
+G4double G4DeuteronEvaporationProbability::CrossSection(const  G4Fragment & fragment, const  G4double K)
 {
        theA=GetA();
@@ -205,5 +205,7 @@
   G4double      ra=0.80;
         
-  ec = 1.44 * theZ * ResidualZ / (1.5*ResidualAthrd+ra);
+  //JMQ 13/02/09 increase of reduced radius to lower the barrier
+  // ec = 1.44 * theZ * ResidualZ / (1.5*ResidualAthrd+ra);
+  ec = 1.44 * theZ * ResidualZ / (1.7*ResidualAthrd+ra);
   ecsq = ec * ec;
   p = p0 + p1/ec + p2/ecsq;
@@ -226,7 +228,7 @@
   elab = K * FragmentA / ResidualA;
   sig = 0.;
- 
+
   if (elab <= ec) { //start for E<Ec
-    if (elab > ecut2)  sig = (p*elab*elab+a*elab+b) * signor;    
+    if (elab > ecut2)  sig = (p*elab*elab+a*elab+b) * signor;
   }           //end for E<Ec
   else {           //start for E>Ec
